﻿

assert( Postal, "Postal not found!")

------------------------------
--      Are you local?      --
------------------------------

local postallib = AceLibrary("PostalLib-1.0")
local L = AceLibrary("AceLocale-2.2"):new("Postal")

----------------------------------
--      Module Declaration      --
----------------------------------

Postal_OpenAll = Postal:NewModule("OpenAll")
Postal_OpenAll.revision = tonumber(string.sub("$Revision: 25567 $", 12, -3))

function Postal_OpenAll:OnEnable()
	self.Button = CreateFrame("Button", "PostalOpenAllButton", InboxFrame, "UIPanelButtonTemplate")
	self.Button:SetWidth(120)
	self.Button:SetHeight(25)
	self.Button:SetPoint("CENTER", InboxFrame, "TOP", -15, -410)
	self.Button:SetText(L["Open All"])
	self.Button.owner = self
	self.Button:SetScript("OnClick", function() this.owner:OpenAll() end)
	self:RegisterEvent("MAIL_CLOSED", "Reset")
end

function Postal_OpenAll:OpenAll()
	self.toprocess = GetInboxNumItems()
	if self.toprocess == 0 then return end
	self.Button:SetScript("OnClick", function() end)
	postallib:DisableInbox(1)
	self:RegisterEvent("Postal10_MailSkipped")
	self:RegisterEvent("Postal10_MailPurged", "ProcessNext")
	self.mailindex = 1
	postallib:PurgeMail(self.mailindex)
end

function Postal_OpenAll:Postal10_MailSkipped()
	self.mailindex = self.mailindex + 1
end

function Postal_OpenAll:ProcessNext()
	postallib:DisableInbox(1)
	self.toprocess = self.toprocess - 1
	if self.toprocess > 0 then
		postallib:PurgeMail(self.mailindex)
	else
		self:Reset()
	end
end

function Postal_OpenAll:Reset()
	self.toprocess = 0
	postallib:DisableInbox(nil)
	if self:IsEventRegistered("Postal10_MailSkipped") then self:UnregisterEvent("Postal10_MailSkipped") end
	if self:IsEventRegistered("Postal10_MailSkipped") then self:UnregisterEvent("Postal10_MailSkipped") end
	self.Button:SetScript("OnClick", function() this.owner:OpenAll() end)
	postallib:DisableInbox(nil)
	InboxFrame_Update()
end
